
--======================================================--
--                      LIBRARIES                       --
--======================================================--

-- IEEE Libraries --
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
--use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_signed.all;
library work;
--use work.float_pkg.all;

entity sumvabs4 is
	
	port
	(
		dataa					:	in	std_logic_vector(31 downto 0);
		datab					: 	in	std_logic_vector(31 downto 0);
		result				:	out	std_logic_vector(31 downto 0)																		
	);
end sumvabs4;

----------------------------------------------------------
--       Somme des valeurs absolues des diffrences  SIMD--
----------------------------------------------------------
architecture comp of sumvabs4 is
signal m3,m2,m1,m0,x3,x2,x1,x0, r3,r2,r1,r0 : std_logic_vector (7 downto 0);
signal r : std_logic_vector(9 downto 0);
begin

m3<= dataa (31 downto 24);
m2<= dataa (23 downto 16);
m1<= dataa (15 downto 8);
m0<= dataa (7 downto 0);
x3<= datab (31 downto 24);
x2<= datab (23 downto 16);
x1<= datab (15 downto 8);
x0<= datab (7 downto 0);


r3 <= (m3-x3) when ((m3-x3)>0) else (x3-m3);
r2 <= (m2-x2) when ((m2-x2)>0) else (x2-m2);
r1 <= (m1-x1) when ((m1-x1)>0) else (x1-m1);
r0 <= (m0-x0) when ((m0-x0)>0) else (x0-m0);
r<= ("00"&r3) + ("00"&r2)+ ("00"&r1) + ("00"&r0); 

result <= "0000000000000000000000" & r; 
end comp; -- end of architecture

--======================================================--
--**                ARCHITECTURE ENDS                 **--
--======================================================--


